#include<stdio.h>
#include<cryptoki.h>
#include<ctextra.h>
#include<ctutil.h>

#define SIZEOFDATA 1024

int main() {
	CK_SESSION_HANDLE hSession;
	//CK_BYTE_PTR pRandomData;
	CK_BYTE pRandomData[SIZEOFDATA];
	CK_RV rv;
	CK_BYTE ErrorString[100]="\0";
	int i=0, j=0;
	FILE *in;
	
	for (j=0;j<SIZEOFDATA;++j) {
		pRandomData[j]=' ';
	}

	printf( "Cryptoki File Encryption $Revision: 1.1 $\n" );
	printf( "Copyright (c) ERACOM Pty. Ltd. 1999,2000\n" );


	/* This must be the first PKCS#11 call made */
	rv = C_Initialize(NULL_PTR);
	if ( rv ) {
		C_ErrorString(rv,ErrorString,sizeof(ErrorString));
		fprintf(stderr, "C_Initialize error %x, %s\n", rv, ErrorString);
	}
	
	/* Check PKCS#11 version */
	rv = CheckCryptokiVersion();
	if ( rv ) {
	printf( "Incompatible PKCS#11 version (0x%x)\n", rv );
	return -1;
	}
	

	rv = C_OpenSession(0, CKF_RW_SESSION|CKF_SERIAL_SESSION, NULL, NULL, &hSession);
	if ( rv ) return 1;
	
	in=fopen("random_0.txt","wb");
	for (i=0;i<51200;++i) {
		C_GenerateRandom(hSession, pRandomData, sizeof(pRandomData));
		for (j=0;j<SIZEOFDATA;++j) {
			fprintf(in,"%c",pRandomData[j]);
			//printf("%c\n",pRandomData[j]);
		}
	}
	fclose(in);

	C_CloseSession(hSession);

	rv = C_Finalize(NULL_PTR);
	if ( rv ) {
		C_ErrorString(rv,ErrorString,sizeof(ErrorString));
		fprintf(stderr, "C_Finalize error %x, %s\n", rv, ErrorString);
	}

return 0;
}